diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
index 9f0adf63a..4289fa091 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
@@ -51,11 +51,11 @@ public class BlockLogicBed
             headPos = tilePos;
             footPos = tilePos.sub(f2hDir, new TilePos());
             if (world.getBlockType(footPos) != this.block) return true;
-            data = world.getBlockData(footPos);
         } else {
             footPos = tilePos;
             headPos = tilePos.add(f2hDir, new TilePos());
             if (world.getBlockType(headPos) != this.block) return true;
+            data = world.getBlockData(headPos);
         }
 
         // Explode in invalid dimensions
@@ -79,17 +79,17 @@ public class BlockLogicBed
             for (final @NotNull Player p : world.players) {
                 if (!p.isPlayerSleeping()) continue;
                 final var otherBedPos = Objects.requireNonNull(p.bedTilePos);
-                if (otherBedPos.equals(footPos)) {
-                    player.sendMessageTranslated("messages.bed.occupied");
+                if (otherBedPos.equals(headPos)) {
+                    player.sendStatusMessageTranslated("messages.bed.occupied");
                     return true;
                 }
             }
-            world.setBlockData(footPos, IS_OCCUPIED.set(data, 0));
+            world.setBlockData(headPos, IS_OCCUPIED.set(data, 0));
         }
         
         // Sleep
-        if (player.sleepInBedAt(footPos.x(), footPos.y(), footPos.z()) == EnumSleepStatus.OK) {
-            world.setBlockData(footPos, IS_OCCUPIED.set(data, 1));
+        if (player.sleepInBedAt(headPos.x(), headPos.y(), headPos.z()) == EnumSleepStatus.OK) {
+            world.setBlockData(headPos, IS_OCCUPIED.set(data, 1));
         }
 
         return true;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java
index 66ac6c306..cb86b616d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java
@@ -334,17 +334,19 @@ public class BlockLogicConduit extends BlockLogic {
     }
 
     private static boolean isEmitting(@NotNull WorldSource world, @NotNull TilePosc tilePos, @NotNull Side side) {
-        int data = world.getBlockData(tilePos);
-        int currentPower = (data >> POWER_SHIFT) & POWER_MASK;
+        final int data = world.getBlockData(tilePos);
+        if ((data & STATE_MASK) == 0) return false;
 
+        final int currentPower = (data >>> POWER_SHIFT) & POWER_MASK;
         if (currentPower == 0) return false;
 
-        TilePos receiverPos = new TilePos(tilePos).add(side.opposite());
-        if (world.getBlockType(receiverPos) == Blocks.WIRE_REDSTONE) {
+        final Side sideAgainst = side.opposite();
+
+        final Block<?> receiver = world.getBlockType(new TilePos(tilePos).add(sideAgainst));
+        if (receiver == Blocks.WIRE_REDSTONE || receiver == Blocks.CONDUIT) {
             return false;
         }
-
-        return isSideOpen(data, side.opposite());
+        return isSideOpen(data, sideAgainst);
     }
 
     private int getNextState(int currentState, @NotNull Side sideQueried) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicEmber.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicEmber.java
index 31c37986c..e32631874 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicEmber.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicEmber.java
@@ -5,11 +5,17 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.animal.MobWolf;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
@@ -36,7 +42,15 @@ public class BlockLogicEmber extends BlockLogic {
 		if (entity != null) {
 			entity.hurt(null, 8, DamageType.BLAST);
 			entity.remainingFireTicks = 100;
-			entity.fling(1.0f, 1.0f, 1.0f, 0.0f);
+			double xd = entity.xd;
+			double zd = entity.zd;
+			double len = Math.sqrt(xd * xd + zd * zd);
+			if (len == 0) {
+				entity.fling(0, 0.65, 0, 0.25F);
+			} else {
+				double f = org.joml.Math.clamp(0.1, 1, len);
+				entity.fling((xd/len) * f, 0.65, (zd/len) * f, 0.25F);
+			}
 		}
 
 		world.setBlockType(tilePos, Blocks.AIR);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
index 9318f640f..3acad5f13 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
@@ -229,4 +229,12 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
             world.scheduleBlockUpdate(tilePos, this.block, tickDelay(world, tilePos));
         }
     }
+
+    @Override
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        super.onNeighborChanged(world, tilePos, block);
+        if (world.getBlockType(tilePos) == this.block) {
+            world.scheduleBlockUpdate(tilePos, this.block, tickDelay(world, tilePos));
+        }
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
index 628d9c951..30776c77a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
@@ -59,6 +59,10 @@ public abstract class BlockLogicLayerBase extends BlockLogic
 
     @Override
     public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
+        return this.getBoundsFromStateMut(source, tilePos);
+    }
+
+    protected @NotNull AABBd getBoundsFromStateMut(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         int data = source.getBlockData(tilePos) & MASK_HEIGHT;
         float f = (float)(2 * (1 + data)) / 16F;
         return new AABBd(0.0F, 0.0F, 0.0F, 1.0F, f, 1.0F);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
index 8df6d9034..13b1d03e7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
@@ -1,10 +1,12 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.block.ItemBlockLayerLeaves;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.WorldSource;
@@ -73,6 +75,11 @@ public class BlockLogicLayerLeaves extends BlockLogicLayerSupportable {
         }
     }
 
+    @Override
+    public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
+        return MASK_PERMANENT;
+    }
+
     public static boolean isPermanent(int meta) {
         return (meta & MASK_PERMANENT) != 0;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
index cf5f41b1a..9f3b9809b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
@@ -29,8 +29,8 @@ public class BlockLogicLayerSnow extends BlockLogicLayerSupportable {
     }
 
     public void accumulate(@NotNull World world, @NotNull TilePosc tilePos) {
-        int myMetadata = world.getBlockData(tilePos);
-        if (myMetadata == 0x7) return;
+        final int myMetadata = world.getBlockData(tilePos);
+        if (myMetadata >= 6) return;
 
         for (final var dir : Direction.horizontal) {
             TilePos dirPos = tilePos.add(dir, new TilePos());
@@ -44,8 +44,9 @@ public class BlockLogicLayerSnow extends BlockLogicLayerSupportable {
 
     @Override
     public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
-        final AABBdc aabb = getBounds();
-        return new AABBd(aabb).setMax(aabb.maxX(), Math.max(aabb.maxY() - 2 / 16f, tilePos.y()), aabb.maxZ());
+        final AABBd aabb = this.getBoundsFromStateMut(source, tilePos);
+        aabb.maxY = Math.max(aabb.minY, aabb.maxY - 2 / 16F);
+        return aabb.translate(tilePos.x(), tilePos.y(), tilePos.z());
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
index 28a8042b0..087ecd16f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBase.java
@@ -365,14 +365,13 @@ public class BlockLogicPistonBase extends BlockLogic {
 
         final TilePos query1 = new TilePos(), query2 = new TilePos();
         final var headPos = new TilePos(basePos).add(dir);
-        final TilePosc sourcePos = query1.set(basePos).add(dir).add(dir, new TilePos());
-
+        final TilePosc sourcePos = headPos.add(dir, new TilePos());
 
         final int len = LINE_LENGTH.get(lineInfo);
 
-        if (world.getTileEntity(headPos) instanceof TileEntityMovingPistonBlock moving && !moving.isExtending) {
-            moving.finalTick();
-        }
+        // if (world.getTileEntity(headPos) instanceof TileEntityMovingPistonBlock moving && !moving.isExtending) {
+        //     moving.finalTick();
+        // }
         world.setBlockTypeRaw(headPos, Blocks.AIR);
         world.removeTileEntity(headPos);
         final var moving = new TileEntityMovingPistonBlock(
@@ -381,6 +380,11 @@ public class BlockLogicPistonBase extends BlockLogic {
         world.setBlockTypeRaw(basePos, Blocks.AIR);
         world.setBlockTypeDataEntity(basePos, Blocks.PISTON_MOVING, data, moving);
 
+
+        if (world.getTileEntity(sourcePos) instanceof TileEntityMovingPistonBlock zeroTicker && zeroTicker.isExtending) {
+            zeroTicker.finalTick();
+        }
+
         if (len > 0) {
             final var line = new MovingLine(len, world, dir, sourcePos, false);
             line.init(query1);
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
index 0dfc65837..158c6cec8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/TileEntityMovingPistonBlock.java
@@ -18,7 +18,7 @@ import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
 import java.util.*;
-import static net.minecraft.core.block.piston.PistonCommon.*;
+// import static net.minecraft.core.block.piston.PistonCommon.*;
 
 /**
  * TODO: make movingTileEntity tick the moving block
@@ -33,10 +33,8 @@ public class TileEntityMovingPistonBlock extends TileEntity implements IMovingBl
     @Nullable TileEntity movingTileEntity;
 
     @NotNull Direction direction;
-    boolean isExtending;
-    boolean isSourcePiston;
-    int lifetime = 0;
-    long lastTick;
+    boolean isExtending, isSourcePiston;
+    int lifetime, latestTick;
     float progressCur = 0F, progressPrev = 0F;
 
     // these would otherwise be reallocated each tick, might as well store them here
@@ -60,7 +58,7 @@ public class TileEntityMovingPistonBlock extends TileEntity implements IMovingBl
     // awkward
     // TODO provide an actual initiallization event that is guaranteed to be called after
     // TODO   tile entity is valid (i.e. not .validate())
-    private boolean isCollisionInited = false;
+    private boolean isCollisionInit = false;
 
     public @NotNull Block<?> movingBlock() { return this.movingBlock; }
     public int movingBlockData() { return this.movingBlockData; }
@@ -86,15 +84,24 @@ public class TileEntityMovingPistonBlock extends TileEntity implements IMovingBl
         @NotNull Block<?> movingBlock, int movingData, @Nullable TileEntity movingEntity, 
         @NotNull Direction direction
     ) {
-        assert movingBlock != Blocks.PISTON_MOVING;
         this.movingBlock = movingBlock;
         this.movingBlockData = movingData;
         this.movingTileEntity = movingEntity;
         this.direction = direction;
         this.isExtending = type.isExtending;
         this.isSourcePiston = type.isSourcePiston;
+
+        if (this.isNested()) {
+            this.tileEntityInvalid = true;
+            LOGGER.warn("attempting to construct a nested TileEntityMovingPistonBlock. invalidated!");
+            return;
+        }
     }
 
+    protected final boolean isNested() {
+        return this.movingBlock == Blocks.PISTON_MOVING || this.movingTileEntity instanceof TileEntityMovingPistonBlock;
+    } 
+
     @Override
     public void validate() {
         super.validate();
@@ -129,14 +136,17 @@ public class TileEntityMovingPistonBlock extends TileEntity implements IMovingBl
         }
         ctx.collisions.clear();
 
-        this.isCollisionInited = true;
+        this.isCollisionInit = true;
     }
 
 
     @Override
     public void tick() {
-        if (!this.isCollisionInited) this.initCollision();
-        this.lastTick = this.worldObj.getWorldTime();
+        assert !this.isNested();
+
+        if (!this.isCollisionInit) this.initCollision();
+
+        this.latestTick = (int) this.worldObj.getWorldTime(); // using only the lower 32 bit should be enough
         if (this.lifetime ++ >= TICKS_TO_EXTEND) {
             this.finalTick();
         } else {
@@ -171,7 +181,7 @@ public class TileEntityMovingPistonBlock extends TileEntity implements IMovingBl
 
     public boolean isInFinalTick() {
         if (this.lifetime < TICKS_TO_EXTEND) return false;
-        return this.lastTick + 1 >= this.worldObj.getWorldTime();
+        return this.latestTick + 1 >= (int)this.worldObj.getWorldTime();
     }
 
     public float xOffset(float partialTick) {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
index 3eed062cb..8404437e9 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
@@ -58,6 +58,7 @@ public final class EntityDispatcher
     public final EntityFactory<ProjectilePebble> FACTORY_PROJECTILE_PEBBLE;
     public final EntityFactory<ProjectileEgg> FACTORY_PROJECTILE_EGG;
     public final EntityFactory<ProjectileArrow> FACTORY_PROJECTILE_ARROW;
+    public final EntityFactory<ProjectileArrowFlaming> FACTORY_PROJECTILE_ARROW_FLAMING;
     public final EntityFactory<ProjectileArrowGolden> FACTORY_PROJECTILE_ARROW_GOLDEN;
     public final EntityFactory<ProjectileArrowPurple> FACTORY_PROJECTILE_ARROW_PURPLE;
     public final EntityFactory<ProjectileSnowball> FACTORY_PROJECTILE_SNOWBALL;
@@ -106,6 +107,7 @@ public final class EntityDispatcher
         FACTORY_PROJECTILE_PEBBLE = addMapping(ProjectilePebble.class, NamespaceID.fromPool("minecraft", "pebble"), ProjectilePebble::new);
         FACTORY_PROJECTILE_EGG = addMapping(ProjectileEgg.class, NamespaceID.fromPool("minecraft", "egg"), ProjectileEgg::new);
         FACTORY_PROJECTILE_ARROW = addMapping(ProjectileArrow.class, NamespaceID.fromPool("minecraft", "arrow"), ProjectileArrow::new);
+        FACTORY_PROJECTILE_ARROW_FLAMING = addMapping(ProjectileArrowFlaming.class, NamespaceID.fromPool("minecraft", "arrow_flaming"), ProjectileArrowFlaming::new);
         FACTORY_PROJECTILE_ARROW_GOLDEN = addMapping(ProjectileArrowGolden.class, NamespaceID.fromPool("minecraft", "arrow_golden"), ProjectileArrowGolden::new);
         FACTORY_PROJECTILE_ARROW_PURPLE = addMapping(ProjectileArrowPurple.class, NamespaceID.fromPool("minecraft", "arrow_purple"), ProjectileArrowPurple::new);
         FACTORY_PROJECTILE_SNOWBALL = addMapping(ProjectileSnowball.class, NamespaceID.fromPool("minecraft", "snowball"), ProjectileSnowball::new);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java b/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java
index 7913026e0..41efa32bd 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java
@@ -350,5 +350,6 @@ public class EntityPainting extends Entity {
         addBorder(Items.DUST_REDSTONE.getDefaultStack(), NamespaceID.fromPool("minecraft", "border_redstone"));
         addBorder(Items.OLIVINE.getDefaultStack(), NamespaceID.fromPool("minecraft", "border_olivine"));
         addBorder(Items.QUARTZ.getDefaultStack(), NamespaceID.fromPool("minecraft", "border_quartz"));
+        addBorder(Items.RUBYGLASS.getDefaultStack(), NamespaceID.fromPool("minecraft", "border_rubyglass"));
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index e0a0e7dc9..952344690 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -1296,7 +1296,7 @@ public abstract class Player
             }
             if (this.bedTilePos == null || !this.bedTilePos.equals(new TilePos(x, y, z))) {
                 if (this.playerSpawnPoint == null || !this.playerSpawnPoint.equals(new TilePos(x, y, z))) {
-                    sendMessageTranslated("messages.bed.setSpawn");
+                    sendStatusMessageTranslated("messages.bed.setSpawn");
                     setPlayerSpawnPoint(new TilePos(x, y, z));
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
index be64c4154..4a0c404fa 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
@@ -23,6 +23,7 @@ public class ProjectileArrow extends Projectile {
     public static final int TYPE_NORMAL = 0;
     public static final int TYPE_PURPLE = 1;
     public static final int TYPE_GOLDEN = 2;
+    public static final int TYPE_FLAMING = 3;
     protected int mobsHit = 0;
     protected @Nullable TilePos tilePos = null;
     protected @Nullable Block<?> inTile = null;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrowFlaming.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrowFlaming.java
index 1cedf70ab..f4220a2ee 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrowFlaming.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrowFlaming.java
@@ -18,19 +18,19 @@ import org.jetbrains.annotations.NotNull;
 
 public class ProjectileArrowFlaming extends ProjectileArrow {
 	public ProjectileArrowFlaming(World world) {
-		super(world, 4);
+		super(world, TYPE_FLAMING);
 		this.stack = new ItemStack(Items.AMMO_ARROW_FLAMING);
 		this.entityBrightness = 1.0F;
 	}
 
 	public ProjectileArrowFlaming(World world, double x, double y, double z) {
-		super(world, x, y, z, 4);
+		super(world, x, y, z, TYPE_FLAMING);
 		this.stack = new ItemStack(Items.AMMO_ARROW_FLAMING);
 		this.entityBrightness = 1.0F;
 	}
 
 	public ProjectileArrowFlaming(World world, Mob owner, boolean doesArrowBelongToPlayer) {
-		super(world, owner, doesArrowBelongToPlayer, 4);
+		super(world, owner, doesArrowBelongToPlayer, TYPE_FLAMING);
 		this.stack = new ItemStack(Items.AMMO_ARROW_FLAMING);
 		this.entityBrightness = 1.0F;
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java b/game/core/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
index 99a71308e..03dcc762e 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
@@ -134,7 +134,5 @@ public class NetEntityHandler {
         registerNetworkEntry(new NetEntryPrimedTNT(), 21);
 
         registerNetworkEntry(new NetEntryBobber(), 30);
-
-        registerNetworkEntry(new NetEntryArrowFlaming(), 32);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryArrow.java b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryArrow.java
index 7cc81e254..acb9b8203 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryArrow.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryArrow.java
@@ -4,6 +4,7 @@ import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.projectile.ProjectileArrow;
+import net.minecraft.core.entity.projectile.ProjectileArrowFlaming;
 import net.minecraft.core.entity.projectile.ProjectileArrowGolden;
 import net.minecraft.core.entity.projectile.ProjectileArrowPurple;
 import net.minecraft.core.net.entity.EntityTracker;
@@ -43,20 +44,20 @@ public class NetEntryArrow implements IVehicleEntry<ProjectileArrow>, ITrackedEn
 
     @Override
     public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner, @Nullable CompoundTag tag) {
-        if (metadata == 2) {
-            return new ProjectileArrowGolden(world, x, y, z);
-        } else if (metadata == 1) {
-            return new ProjectileArrowPurple(world, x, y, z);
-        } else {
-            return new ProjectileArrow(world, x, y, z, metadata);
-        }
+        return switch (metadata) {
+            case ProjectileArrow.TYPE_NORMAL -> new ProjectileArrow(world, x, y, z, metadata);
+            case ProjectileArrow.TYPE_PURPLE -> new ProjectileArrowPurple(world, x, y, z);
+            case ProjectileArrow.TYPE_GOLDEN -> new ProjectileArrowGolden(world, x, y, z);
+            case ProjectileArrow.TYPE_FLAMING -> new ProjectileArrowFlaming(world, x, y, z);
+            default -> new ProjectileArrow(world, x, y, z, metadata);
+        };
     }
 
     @Override
     public PacketAddEntity getSpawnPacket(EntityTrackerEntry tracker, ProjectileArrow trackedObject) {
-        Mob entityliving = trackedObject.owner;
+        Mob owner = trackedObject.owner;
         return new PacketAddEntity(trackedObject,
-            trackedObject.getArrowType(), entityliving == null ? -1 : entityliving.id,
+            trackedObject.getArrowType(), owner == null ? -1 : owner.id,
             trackedObject.xd, trackedObject.yd, trackedObject.zd);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java b/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java
index 7abca18e0..d5770297c 100644
--- a/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/MathHelper.java
@@ -573,4 +573,12 @@ public class MathHelper {
 
         return value;
     }
+
+    public static float floorMod(float x, float y) {
+        return (float) (x - Math.floor(x / y) * y);
+    }
+
+    public static double floorMod(double x, double y) {
+        return (x - Math.floor(x / y) * y);
+    }
 }
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang
index bf8544bbf..11bdbdeb3 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/options.lang
@@ -439,4 +439,5 @@ key.debug.reloadchunks=Reload chunks
 key.debug.smoothlighting=Toggle smooth lighting
 key.debug.releasecursor=Release Cursor
 key.debug.shortcuts=Show keyboard shortcuts
-key.debug.loadChunksQuickly=Load Chunks Quickly
\ No newline at end of file
+key.debug.loadChunksQuickly=Load Chunks Quickly
+key.debug.toggleFrameLimit=Toggle Frame Limit
\ No newline at end of file
diff --git a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
index 8be6bfd6a..04cc95bc3 100644
--- a/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/game/server/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -168,12 +168,11 @@ public class WorldServer extends World {
         final int required = getPlayersRequiredToSkipNight();
         int playersSleeping = 0;
         for (final var p : players) {
-            if (!p.isPlayerSleeping()) break;
-            if (playersSleeping >= required) {
+            if (!p.isPlayerSleeping()) continue;
+            if (++playersSleeping >= required) {
                 this.enoughPlayersSleeping = true;
                 break;
             }
-            playersSleeping++;
         }
 
         if (player == null) return;
